2 #*************************************************************************
4 # DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
6 # Copyright 2000, 2010 Oracle and/or its affiliates.
8 # OpenOffice.org - a multi-platform office productivity suite
10 # This file is part of OpenOffice.org.
12 # OpenOffice.org is free software: you can redistribute it and/or modify
13 # it under the terms of the GNU Lesser General Public License version 3
14 # only, as published by the Free Software Foundation.
16 # OpenOffice.org is distributed in the hope that it will be useful,
17 # but WITHOUT ANY WARRANTY; without even the implied warranty of
18 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
19 # GNU Lesser General Public License version 3 for more details
20 # (a copy is included in the LICENSE file that accompanied this code).
22 # You should have received a copy of the GNU Lesser General Public License
23 # version 3 along with OpenOffice.org. If not, see
24 # <http://www.openoffice.org/license.html>
25 # for a copy of the LGPLv3 License.
27 #*************************************************************************
29 # environment setup yet?
30 if [ -z "$TARFILE_LOCATION" ]; then
34 # we want to clone if we are in the bootstrap git repo and clone does not exist yet
35 # we need to test for a .git in order not to clone after rsync if we are called in
36 # the inner autogen of the buid-repo based build
40 echo "Looking for $1 ..."
44 echo "missing required archive; run './download' again";
50 if [ -z "$GIT_LINK_SRC" ]; then
53 # space-saving clone from another local workdir
55 branch
=$
(git symbolic-ref HEAD | cut
-d"/" -f 3)
56 for i
in $GIT_REPO_NAMES ; do
57 bin
/git-new-workdir
$GIT_LINK_SRC/$i clone
/$i $branch
58 for d
in clone
/$i/* ; do
59 if [ "${d}" != "clone/$i/git-hooks" ]; then
60 ln -sfn ${d} $
(basename ${d})
67 if [ ! -d "$TARFILE_LOCATION" ]; then
68 mkdir
$TARFILE_LOCATION
70 if [ ! -d "$TARFILE_LOCATION" ]; then
71 echo "Error: Cannot create $TARFILE_LOCATION."
76 if [ -z "$FILELIST" ]; then
77 echo "No filelist provided, using the default ooo.lst."
81 # check for wget and md5sum
84 curl
=`which curl 2>/dev/null`
86 for i
in wget
/usr
/bin
/wget
/usr
/local
/bin
/wget
/usr
/sfw
/bin
/wget
/opt
/sfw
/bin
/wget
/opt
/local
/bin
/wget
; do
87 eval "$i --version" > /dev
/null
2>&1
89 if [ $ret -eq 0 ]; then
95 if [ -z "$wget" -a -z "$curl" ]; then
96 echo "ERROR: neither wget nor curl found!"
100 for i
in md5
md5sum /usr
/local
/bin
/md5sum gmd5sum
/usr
/sfw
/bin
/md5sum /opt
/sfw
/bin
/gmd5sum
/opt
/local
/bin
/md5sum; do
101 if [ "$i" = "md5" ]; then
102 eval "$i -x" > /dev
/null
2>&1
104 eval "$i --version" > /dev
/null
2>&1
107 if [ $ret -eq 0 ]; then
113 if [ "$md5sum" = "md5" ]; then
114 if md5
-r < /dev
/null
> /dev
/null
2>/dev
/null
; then
116 elif md5
-n < /dev
/null
> /dev
/null
2>/dev
/null
; then
121 if [ -z "$md5sum" ]; then
122 echo "Warning: no md5sum: found!"
126 logfile
=$TARFILE_LOCATION/fetch.log
131 if [ "$1" != "" ]; then
132 if [ ! -f "../$2" ]; then
134 if [ ! -z "$wget" ]; then
135 $wget --progress=dot
:mega
-N $1/$2 2>&1 |
tee -a $logfile
138 $curl $file_date_check -O $1/$2 2>&1 |
tee -a $logfile
141 if [ $wret -ne 0 ]; then
146 if [ -f $2 -a -n "$3" -a -n "$md5sum" ]; then
147 sum=`$md5sum $md5special $2 | sed "s/ .*//"`
148 if [ "$sum" != "$3" ]; then
149 echo checksum failure
for $2 2>&1 |
tee -a $logfile
162 filelist
=`cat $FILELIST`
163 mkdir
-p $TARFILE_LOCATION/tmp
164 cd $TARFILE_LOCATION/tmp
165 echo $$
> fetch-running
166 for i
in $filelist ; do
168 if [ "$i" != `echo $i | sed "s/^http:\///"` ]; then
170 # TODO: check for comment
172 if [ "$tarurl" != "" ]; then
173 sum=`echo $i | sed "s/-.*//"`
174 downloaditem
$tarurl $i $sum
179 if [ "$COM" = "MSC" ]; then
180 downloaditem
"http://download.microsoft.com/download/platformsdk/Redist/5.0.2195.1/W9XNT4/EN-US/" "dbghinst.EXE" "096f1d53d9ba09cde27d6f7c2ea6cc47"
181 downloaditem
"http://download.microsoft.com/download/a/b/c/abc45517-97a0-4cee-a362-1957be2f24e1/" "WindowsXP-KB975337-x86-ENU.exe" "946d00d87e4094f3a6e425e2d538eadd"
184 if [ -f $start_dir/sources.ver
-a ! -d $start_dir/.git
] ; then
185 # these sources are from a tarball, so get the other source tarballs
186 .
$start_dir/sources.ver
187 # sources are put into "major.minor.micro" version directory on the dowload site, e.g. "3.5.2"
188 lo_bugfix_release_sources_ver
=`echo $lo_sources_ver | sed -e "s/\([0-9]*\.[0-9]*\.[0-9]*\).*/\1/"`
189 lo_src_dir
="$start_dir/src"
190 mkdir
-p "$lo_src_dir"
191 for piece
in `cat $start_dir/bin/repo-list` ; do
192 tarname
="libreoffice-$piece-$lo_sources_ver"
193 if [ ! -f "$TARFILE_LOCATION/$tarname.tar.xz" ] ; then
194 downloaditem
"http://download.documentfoundation.org/libreoffice/src/$lo_bugfix_release_sources_ver" "$tarname.tar.xz" ""
196 $start_dir/bin
/unpack-sources
$start_dir $TARFILE_LOCATION/$tarname.
tar.xz
200 rm $TARFILE_LOCATION/tmp
/*-*
203 if [ ! -z "$failed" ]; then
205 echo ERROR
: failed on
:
206 for i
in $failed ; do
212 if [ "$COM" = "MSC" -a -n "$md5sum" ]; then
213 # This can be run only on Windows itself (Cygwin)
214 TMPUNPACK
=`cygpath -d $TARFILE_LOCATION/tmp`
215 chmod a
+w
$TARFILE_LOCATION/tmp
216 if [ ! -f .
/external
/dbghelp
/dbghelp.dll
-a -f $TARFILE_LOCATION/dbghinst.EXE
]; then
217 if [ ! -x $TARFILE_LOCATION/dbghinst.EXE
]; then
218 chmod +x
$TARFILE_LOCATION/dbghinst.EXE
220 $TARFILE_LOCATION/dbghinst.EXE
/T
:$TMPUNPACK /C
221 sum=`$md5sum $md5special $TARFILE_LOCATION/tmp/dbghelp.exe | sed "s/ .*//"`
222 if [ "$sum" = "cd3086a91e37965dd761ef5fd5df5b15" ]; then
223 unzip -LL -j -o -d .
/external
/dbghelp
$TARFILE_LOCATION/tmp
/dbghelp.exe
226 if [ ! -f .
/external
/gdiplus
/gdiplus.dll
-a -f $TARFILE_LOCATION/WindowsXP-KB975337-x86-ENU.exe
]; then
227 gdiplus_dll_path
=asms
/10/msft
/windows
/gdiplus
/gdiplus.dll
229 # Run it through cmd so that the UAC prompt is displayed
231 echo "NOTE: We are running the Microsoft KB975337 security fix installer"
232 echo "to get gdiplus.dll. You will most probably get a UAC prompt now."
233 echo "If you trust us, just enter your administrator password."
234 echo "The security fix is run with the /extract switch to just unpack"
236 echo "If you don't trust us, just get gdiplus.dll yourself and put it"
237 echo "in external/gdiplus/gdiplus.dll."
238 echo "gdiplus.dll is included in the LibreOffice installer for the benefit of"
239 echo "Windows 2000 users."
240 # A few empty lines so that the above is visible even if the taskbar's auto-hide is turned on,
241 # and the UAC prompt caused it to taise (with a blinking icon for the UAC prompt)
245 cmd
/c
"`cygpath -d $TARFILE_LOCATION/WindowsXP-KB975337-x86-ENU.exe` /extract:$TMPUNPACK /q"
246 if [ -f $TARFILE_LOCATION/tmp
/$gdiplus_dll_path ]; then
247 echo "Extraction succeeded"
248 sum=`$md5sum $md5special $TARFILE_LOCATION/tmp/$gdiplus_dll_path | sed "s/ .*//"`
249 if [ "$sum" = "4721ab485e0c29cd1617a5f296b9cc47" ]; then
250 cp $TARFILE_LOCATION/tmp
/$gdiplus_dll_path .
/external
/gdiplus
/gdiplus.dll
252 echo "But unexpected checksum of $gdiplus_dll_path"
255 echo "WindowsXP-KB975337-x86-ENU.exe did not unpack the expected $gdiplus_dll_path"
260 # OxygenOffice extras
261 for pack
in $OOOP_FONTS_PACK $OOOP_GALLERY_PACK $OOOP_SAMPLES_PACK $OOOP_TEMPLATES_PACK ; do
262 check_file
$TARFILE_LOCATION/$pack
263 echo "Unpacking OxygenOffice extra '$pack' ..."
264 unzip -o -q $TARFILE_LOCATION/$pack -d $SRC_ROOT/extras
/source
267 if [ "$OXYGENOFFICE_PACK" = "YES" ] ; then
268 check_file
$TARFILE_LOCATION/$OXYGENOFFICE_PACK
269 echo "Unpacking OxygenOffice '$OXYGENOFFICE_PACK' ..."
270 unzip -o -q $TARFILE_LOCATION/$OXYGENOFFICE_PACK -d $SRC_ROOT/src
274 for pack
in $BARCODE_EXTENSION_PACK $DIAGRAM_EXTENSION_PACK $VALIDATOR_EXTENSION_PACK $WATCH_WINDOW_EXTENSION_PACK $NUMBERTEXT_EXTENSION_PACK $HUNART_EXTENSION_PACK $TYPO_EXTENSION_PACK $GOOGLE_DOCS_EXTENSION_PACK $OOOBLOGGER_EXTENSION_PACK $SUNTEMPLATES_DE_PACK $SUNTEMPLATES_EN_US_PACK $SUNTEMPLATES_ES_PACK $SUNTEMPLATES_FR_PACK $SUNTEMPLATES_HU_PACK $SUNTEMPLATES_IT_PACK; do
275 check_file
$TARFILE_LOCATION/$pack
276 packfilename
=`echo "$pack" | cut -f 2- -s -d - | cut -f 1 -d _`
277 echo "Copy extension: '$pack' as '$packfilename.oxt' ..."
278 mkdir
-p $SRC_ROOT/extras
/source
/extensions
/ ||
exit 1
279 cp $TARFILE_LOCATION/$pack $SRC_ROOT/extras
/source
/extensions
/$packfilename.oxt ||
exit 1
282 [ -x "post_download" ] ||
{ echo "'post_download' script not found, run ./autogen.sh." ; exit 1 ; }
284 # Save the config.log from the main configure script
285 # and restore it after running post_download.
286 mv config.log config.log.save
288 .
/post_download
--build=$BUILD_PLATFORM --host=$HOST_PLATFORM
289 post_download_status
=$?
291 test -f config.log
&& mv config.log post_download.log
292 mv config.log.save config.log
294 exit $post_download_status
298 # indent-tabs-mode: nil
301 # vim:set shiftwidth=4 softtabstop=4 expandtab: